<template>
  <div style="min-height: 100px" v-if="showing">
    <q-inner-loading :showing="showing" size="lg">
      <!--
    transition-hide="fade"
    transition-duration="1000"
    -->
      <q-spinner-ball size="50px" color="primary" />
      <div class="q-inner-loading__label text-primary" style="font-size: 1.1em">
        Procesando solicitud
      </div>
    </q-inner-loading>
    <!-- <div style="height: 100px" v-if="showing"></div>
 -->
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, onMounted, watch, toRef, ref } from 'vue';
import { useQuasar, QSpinnerInfinity } from 'quasar';

/**
 *  NOTAS -
 *  al utiliar el compoente en  q-table dentro del slot:loading  no dispara bien el evento de ocultar,
 *  por esta razon, watch no detecta el cambio de estado, por esta razon, no cierra la notificacion cuando termina de cargar.
 *
 */
export default defineComponent({
  name: 'componente-loading',
  props: {
    showing: {
      //type: Boolean as PropType<boolean>,
      type: Boolean,
      required: true,
    },
    text: {
      type: String as PropType<string>,
      default: 'Obteniendo Datos ....',
      required: false,
    },
  },
  setup(props) {
    const $q = useQuasar();
    const estado = toRef(props, 'showing');
    const dismiss = ref();

    onMounted(() => {
      dismiss.value = motificacion();
    });

    watch(estado, (newValue) => {
      if (newValue) {
        dismiss.value = motificacion();
      }

      if (!newValue) {
        dismiss.value(); // cierro la notificaicon cuando cambio de estado.
      }
    });

    function motificacion() {
      if (!props.showing) {
        return;
      }
      return $q.notify({
        spinner: QSpinnerInfinity,
        group: true,
        message: props.text,
        progress: true,
        type: 'info',
        timeout: 1000,
        badgeStyle: 'opacity: 0', // Oculto el numero notificaciones agrupadas
        position: 'bottom', // right
      });
    }

    return {
      props,
    };
  },
});
</script>
